export declare type CancellablePromise<T> = Promise<T> & {
    cancel(): void;
};
export declare type Promisify<T extends (...args: any[]) => IterableIterator<any>> = T extends () => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? () => CancellablePromise<void> : () => CancellablePromise<Exclude<B1, Promise<any>>> : T extends (a1: infer A1) => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? (a1: A1) => CancellablePromise<void> : (a1: A1) => CancellablePromise<Exclude<B1, Promise<any>>> : T extends (a1: infer A1, a2: infer A2) => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? (a1: A1, a2: A2) => CancellablePromise<void> : (a1: A1, a2: A2) => CancellablePromise<Exclude<B1, Promise<any>>> : T extends (a1: infer A1, a2: infer A2, a3: infer A3) => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? (a1: A1, a2: A2, a3: A3) => CancellablePromise<void> : (a1: A1, a2: A2, a3: A3) => CancellablePromise<Exclude<B1, Promise<any>>> : T extends (a1: infer A1, a2: infer A2, a3: infer A3, a4: infer A4) => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? (a1: A1, a2: A2, a3: A3, a4: A4) => CancellablePromise<void> : (a1: A1, a2: A2, a3: A3, a4: A4) => CancellablePromise<Exclude<B1, Promise<any>>> : T extends (a1: infer A1, a2: infer A2, a3: infer A3, a4: infer A4, a5: infer A5) => IterableIterator<infer B1> ? Exclude<B1, Promise<any>> extends never ? (a1: A1, a2: A2, a3: A3, a4: A4, a5: A5) => CancellablePromise<void> : (a1: A1, a2: A2, a3: A3, a4: A4, a5: A5) => CancellablePromise<Exclude<B1, Promise<any>>> : never;
export declare function promisify<T extends (...args: any[]) => IterableIterator<any>>(generator: T): Promisify<T>;
